# CũC|[g
import tkinter          # OtBbNXp
from tkinter import *
from tkinter import font
import pigpio           # I2C, GPIO
import time
import myVL53L3 as VL   # VL53L3

XSDN = 19               # XSDN ڑ GPIO
INTR = 16               # INTR ڑ GPIO

pi = pigpio.pi()        # GPIOɃANZX邽߂̃CX^X쐬
pi.set_mode(XSDN,pigpio.OUTPUT) # XSDN pin o͐ݒ
addr = 0x29             # ݂VL53̃AhX(0x52(8bit))
h = pi.i2c_open(1,addr) # I2C̃nh擾

pi.write(XSDN,0)        #  XSDN = "L"
time.sleep(0.1)         # 0.1s EFCg
pi.write(XSDN,1)        # XSDN = "H"
time.sleep(0.1)         # 0.1s EFCg

pi.i2c_write_device(h, [0x01, 0x0f])    # Model_ID?
(count, buf) = pi.i2c_read_device(h, 2) # Model_ID = 0xEA, Module_Type = 0xAA 
print(hex(buf[0]), hex(buf[1]))

ret = VL.VL53LX_WaitDeviceBooted(pi, h) # VL53֐̃R[
print(ret)
VL.VL53LX_DataInit(pi, h)           # VL53L3̏
VL.VL53LX_StartMeasurement(pi, h)   # VL53L3̑Jn
time.sleep(0.3)         #0.3s EFCg

root = tkinter.Tk()     # tkinter̃CX^X쐬

root.title("VL53L3ɂ鋗")   # EBhẼ^CgVL53L3ɂ鋗
root.geometry("800x700+0+0")    # EBhETCY800x700ōɔzu

   # Ot\ʂ̑傫500x700, wiFgray90
c0 = Canvas(root, bg="gray90", height=500, width=700)
c0.place(x=70, y = 20)  # EBhE70, 20̈ʒuc0\

xy = [0] * 12000        # xyz̗vf120000ŏ
for num in range(0, 6000):
    xy[num * 2] = num * 0.98    # ̒l̐ݒ

font1 = font.Font(family='Arial', size=14)  # tHgw
font2 = font.Font(family='Times', size=14)  # tHgw

# W
# ڐl̕\
for num in range(0, 5):
    label3 = tkinter.Label(root, text=str((200-num*50)).rjust(3), font=font2)
    label3.place(x=35, y=25+120*num)
# ڐx̕\
label3 = tkinter.Label(root, text="", font=font2)
label3.place(x=10, y=200+30*1)
label3 = tkinter.Label(root, text="", font=font2)
label3.place(x=10, y=200+30*2)
label3 = tkinter.Label(root, text="[cm]", font=font2)
label3.place(x=0, y=200+30*3)

# ڐl̕\
for num in range(0, 11):
    label3 = tkinter.Label(root, text=num*10, font=font2)
    label3.place(x=60+70*num, y=525)
# ڐx̕\
label3 = tkinter.Label(root, text="ԁmsn", font=font2)
label3.place(x=380, y=550)

k0 = 0      # show_time֐Ŏgϐk0̏
# show_time֐(50msɃR[)
def show_time():
    global k0
    global xy

   # VL53L3̑f[^̏ł̊mF
    ret = VL.VL53LX_GetMeasurementDataReady(pi, h)
    print(ret)
    time.sleep(0.01)    # 10ms EFCg
    
    buf = [0] * 100     # pzϐbuf̏
   # VL53L3̑f[^̎擾
    buf = VL.VL53LX_GetMultiRangingData(pi, h, buf)
    time.sleep(0.5)    # 0.5s EFCg
    
   # VL53L3̑f[^̉
    for j in range(0, buf[5]):  # buf[5]͑ł̂̐(ő4P)
      # ŏ̍sCounts, Objs,f[^\
      # s͑f[^\
        if j == 0:
            c = "Count= " + str(buf[4])
            c = c + ", #Objs=" + str(buf[5])
        else:
            c = c + "                                 "
      # StatusDvZ        
        c = c + " status=" + str(buf[20*j+26]) + ", D={0:>4}". format(str(256 * buf[20*j+25] + buf[20*j+24]))
      # SignalvZ        
        c = c + "mm, Signal={0:>5.2f} Mcps,". format((16777216 * buf[20*j+15] + 65536 * buf[20*j+14] + 256 * buf[20*j+13] + buf[20*j+12]) / 1000000 * 15.26)
      # AmbientvZ        
        c = c + " Ambient={0:>5.2f} Mcps". format((16777216 * buf[20*j+19] + 65536 * buf[20*j+18] + 256 * buf[20*j+17] + buf[20*j+16]) / 1000000 * 15.26) + "\n"

   # VL53L3INTNAJn
    VL.VL53LX_ClearInterruptAndStartMeasurement(pi, h)

   # ̌vZ(łȂꍇD = 0)
    D = 256 * buf[25] + buf[24]
   # łꍇf[^XV
    if D != 0:
        k0 += 1                             # Xl1
        xy[2*k0 + 1] =500-D*0.25*480/500    # Ylݒ

        label3 = tkinter.Label(root, text=c, font=font1)    # f[^̕\
        label3.place(x=50, y=600)           # ʒu̓EBhẺ
        c0.delete("all")                    # LoXNA
        
        # yڐ̕\
        for j in range(1, 10):
            c0.create_line(70*j,0,70*j,500,fill="gray",width=1)
        
        # xڐ̕\
        for j in range(0, 4):
            c0.create_line(0,20+120*j,700,20+120*j,fill="gray",width=1)

        c0.create_line(xy,fill="yellow",width=3)    # f[^̃vbg
    root.after(50, show_time)       # 50msshow_time()R[

show_time()                         # show_time()R[
root.mainloop()                     # mainloop[v
pi.i2c_close(h)                     # I2C
 


